using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Security.Cryptography.X509Certificates;
using System.Net;
using System.Net.Security;
using System.Web;

/*File nella directory "bin":
 * soap_2dplus_https.wsdl (WSDL del WebServer)
 * PeS-client-A.010213.p12 (Certificato per lo store Microsoft)
 * PeS-client-A.010213.cer (Certificato da caricare da programma)
 * ldipiazza_cittadinanza.xml (XML di test da inviare)
 */

namespace ClientSOAP2DPlus
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        /// <summary>
        /// Encode Base64
        /// </summary>
        /// <param name="toEncode"></param>
        /// <returns></returns>
        static public string EncodeTo64(string toEncode)
        {

            byte[] toEncodeAsBytes

                  = System.Text.ASCIIEncoding.ASCII.GetBytes(toEncode);

            string returnValue

                  = System.Convert.ToBase64String(toEncodeAsBytes);

            return returnValue;

        }

        /// <summary>
        /// Decode Base64
        /// </summary>
        /// <param name="encodedData"></param>
        /// <returns></returns>
        static public string DecodeFrom64(string encodedData)
        {

            byte[] encodedDataAsBytes

                = System.Convert.FromBase64String(encodedData);

            string returnValue =

               System.Text.ASCIIEncoding.ASCII.GetString(encodedDataAsBytes);

            return returnValue;

        }

        /// <summary>
        /// C# to convert a string to a byte array.
        /// </summary>
        /// <param name="str"></param>
        /// <returns></returns>
        public static byte[] StrToByteArray(string str)
        {
            System.Text.ASCIIEncoding  encoding=new System.Text.ASCIIEncoding();
            return encoding.GetBytes(str);
        }

        /// <summary>
        /// Read file Certificate X509 from disk
        /// </summary>
        /// <param name="fileName"></param>
        /// <returns></returns>
        public static byte[] ReadFileCer(string fileName)
        {
            FileStream f = new FileStream(fileName, FileMode.Open, FileAccess.Read);
            int size = (int)f.Length;
            byte[] data = new byte[size];
            size = f.Read(data, 0, size);
            f.Close();
            return data;
        }

        /// <summary>
        /// Trust Certificate
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="cert"></param>
        /// <param name="chain"></param>
        /// <param name="errors"></param>
        /// <returns></returns>
        public static bool TrustAllCertificateCallback(object sender,
           X509Certificate cert, X509Chain chain, SslPolicyErrors errors)
        {
            //ATTENZIONE: Qui deve essere fatto un controllo sul certificato!
            //return (cert.Equals; //ed un controllo dei campi relativi...)
            return true;
        }


        //OnClick su evento pulsante principale
        private void OnClick(object sender, EventArgs e)
        {
            string localFolder = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetEntryAssembly().Location);
            string filename = Path.Combine(localFolder, "ldipiazza_cittadinanza.xml");
            string filenameCer = Path.Combine(localFolder, "PeS-client-A.010213.cer");
            string s = null;
            //Carica file 
            using (StreamReader rdr = File.OpenText(filename))
            {
                s = rdr.ReadToEnd();
            }
            //OK Considera il certificato OK; 
            //Vedi(http://www.codeproject.com/KB/webservices/web_service_over_SSL.aspx)
            //Assegno funzione per riconoscimento certificato
            System.Net.ServicePointManager.ServerCertificateValidationCallback =
            new System.Net.Security.RemoteCertificateValidationCallback(TrustAllCertificateCallback);
            //Carica certificato
            X509Certificate2 Certificate = new X509Certificate2();
            // Load the client certificate from a file. (Non pi valido)
            // X509Certificate x509 = X509Certificate.CreateFromCertFile(@"c:\user.cer") ;
            //Debug
            Console.WriteLine(Path.Combine(localFolder, filenameCer));
            //Create X509Certificate2 object from .cer file.
            if(File.Exists(Path.Combine(localFolder, filenameCer)))
	        {	
            	byte[] rawData = ReadFileCer(Path.Combine(localFolder, filenameCer));
				//Importa
            	Certificate.Import(rawData);
            }
            //Verifica se  il certificato giusto
            //Cerca e carica certificato
            X509Store store = null;

            // Selezione dello store da cui recuperare il certificato client
            if (false)
            {
                store = new X509Store(StoreName.TrustedPublisher, StoreLocation.LocalMachine);
            }
            else
            {
                store = new X509Store(StoreName.My, StoreLocation.CurrentUser);
            }

            store.Open(OpenFlags.ReadOnly | OpenFlags.OpenExistingOnly);

            X509Certificate2Collection storecollection = (X509Certificate2Collection)store.Certificates;

            bool bFound = false;
                
            //Chiama Oggetto SOAP
            ClientSOAP2DPlus.WebReference.get2DPlusService MyClientSOAP = new ClientSOAP2DPlus.WebReference.get2DPlusService();
            //Oggetto di Output
            ClientSOAP2DPlus.WebReference.OutputStruct ObjOut = new ClientSOAP2DPlus.WebReference.OutputStruct();
            //Oggetto di Input
            ClientSOAP2DPlus.WebReference.i2DPlusInputStruct1 ObjInput = new ClientSOAP2DPlus.WebReference.i2DPlusInputStruct1();           
            //Convert in base64
            s = EncodeTo64(s);
            //Carica dati
            ObjInput.b64data = StrToByteArray(s);
            //ObjInput.config_file = "mytestcfg";
            ObjInput.config_file = "test2";
            //MyClientSOAP.ClientCertificates.Add(Certificate); (Se si vuole caricare direttamente il certificato)
            // Ricerca del certificato client in base al subject specificato
            foreach (X509Certificate2 x509 in storecollection)
            {
                //Console.WriteLine(x509.SubjectName.Name); //Debug
                //Si coonfronta il certificato caricato con quanto presente nel repository Microsoft
                //e quello viene passatp
                if (x509.SubjectName.Name == Certificate.SubjectName.Name)
                {
                    //Inserisci il certificato
                    MyClientSOAP.ClientCertificates.Add(x509);
                    bFound = true;
                    break;
                }
            }
            //Chiama metodo SOAP
            try
            {
                ObjOut = MyClientSOAP.get2DPlus1(ObjInput);
            }
            catch(Exception ex)
            {
                throw new Exception("Error: " + ex.Message);
            }
            //Visualiziamo output utente
            if (ObjOut.image_res != (null))
            {
                // C# to convert a byte array to a string.
                byte[] dBytes = ObjOut.image_res;
                string strOut;
                System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
                strOut = enc.GetString(dBytes);
                richTextBoxOutput.Clear();
                //Mostra sul RichTextBox i dati ricavati
                richTextBoxOutput.AppendText(strOut);

                //ATTENZIONE:
                //L'immagine dovrebbe essere ulteriormente decodificata portando i dati da Base64 a Bytes
                //per poi salvare il relativo Array di Byte su un file immagine
            }
            else
            {
                //Mostra errori
                richTextBoxOutput.Clear();
                richTextBoxOutput.AppendText(Convert.ToString(ObjOut.error_code));
            }
        }
    }
}